/*
 * Test in and out state actions.
 */

#include <stdio.h>

struct state_chart
{
	int curs;
};

%% state_chart
{
	action a { printf("a"); }
	action b { printf("b"); }
	action hexa { printf("a"); }
	action hexb { printf("b"); }

	hex_a = '0x' '0'* '61' @hexa;
	hex_b = '0x' '0'* '62' @hexb;

	a = 'a' @a | hex_a;
	b = 'b' @b | hex_b;
	ws = ' '+;

	machine = 
		start: ( 
			a -> st1 |
			b -> st2 | 
			zlen -> final 
		),
		st1: ( 
			a -> st1 | 
			ws -> start |
			zlen -> final 
		),
		st2: ( 
			b -> st2 |
			ws -> start |
			zlen -> final
		);
	
	main := ( machine '\n' )*;
}

#define BUFSIZE 1024
char buf[BUFSIZE];

struct state_chart sc;

int main()
{
	state_chart_init( &sc );
	while ( 1 ) {
		int len = fread( buf, 1, BUFSIZE, stdin );
		state_chart_execute( &sc, buf, len );
		if ( len != BUFSIZE )
			break;
	}
	state_chart_finish( &sc );
	printf("\n");
	return 0;
}
